#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = tslib_1.__importDefault(require("path"));
var fs_1 = tslib_1.__importDefault(require("fs"));
var child_process_1 = require("child_process");
var unique_string_1 = tslib_1.__importDefault(require("unique-string"));
var inquirer_1 = tslib_1.__importDefault(require("inquirer"));
var colors_1 = tslib_1.__importDefault(require("colors"));
// CN 您的名字与姓氏是什么?
// OU 您的组织单位名称是什么?
// O  您的组织名称是什么?
// L  您所在的城市或区域名称是什么?
// ST 您所在的省/市/自治区名称是什么?
// C  该单位的双字母国家/地区代码是什么?
var name = 'release.keystore';
var signPath = path_1.default.resolve("android/app/" + name);
var createSignature = function () {
    var storePassword = unique_string_1.default();
    var keyPassword = unique_string_1.default();
    var alias = path_1.default.basename(process.cwd());
    child_process_1.execSync("keytool -genkey -v -keyalg RSA -keysize 2048 -validity 10000 -keystore \"" + signPath + "\" -storepass \"" + storePassword + "\" -alias \"" + alias + "\" -keypass \"" + keyPassword + "\" -dname \"CN=NoName, O=NoOrg, C=NoCountry\"");
    console.log('');
    console.log(colors_1.default.bgBlack(colors_1.default.white('Copy green color code from below to file: ./android/app/build.gradle')));
    console.log("android {\n    ...\n    signingConfigs {\n        ...\n        release {\n            " + colors_1.default.green("storeFile file('" + name + "')") + "\n            " + colors_1.default.green("storePassword \"" + storePassword + "\"") + "\n            " + colors_1.default.green("keyAlias \"" + alias + "\"") + "\n            " + colors_1.default.green("keyPassword \"" + keyPassword + "\"") + "\n        }\n    }\n\n    buildTypes {\n        ...\n        release {\n            ...\n            " + colors_1.default.green('signingConfig signingConfigs.release') + "\n        }\n    }\n    ...\n}");
};
if (fs_1.default.existsSync(signPath)) {
    inquirer_1.default.createPromptModule()({
        type: 'list',
        name: 'override',
        message: '\nHere exists a signature file, do you want to override it?\n',
        prefix: '',
        suffix: '',
        choices: [
            {
                name: '1. No. Stop doing that',
                value: false,
            },
            {
                name: '2. Yes, I want to override\n',
                value: true,
            },
        ],
    }).then(function (_a) {
        var override = _a.override;
        if (override) {
            fs_1.default.unlinkSync(signPath);
            createSignature();
        }
    });
}
else {
    createSignature();
}
